import chalk from 'chalk';
import Tentamen from 'tentamen';

let tentamen = new Tentamen({
  fn: str => str.startsWith('a'),
  error: e => e.message
});

class Exception {
  constructor (message) {
    this.message = chalk`{red error:} ${message}\n  {cyan at line:col}`;
  }
}

tentamen.suite('truthy cases');
tentamen.add('absolutely', 'absolutely', true);
tentamen.add('acknowledge', 'acknowledge', true);

tentamen.suite('falsy cases');
tentamen.add('tentamen', 'tentamen', false);
tentamen.add('percentage', 'percentage', false);

tentamen.suite('Array.split', str => str.split(''));
tentamen.add('word', 'split', ['s', 'p', 'l', 'i', 't']);
tentamen.add('single character', 'e', ['e']);

tentamen.suite('concat', str => str.concat('a'));
tentamen.add('case 1', 'A', 'Aa');
tentamen.add('case 2', 1, '1a');

tentamen.suite('throws', () => { throw new Exception('something went wrong') });
tentamen.add('should throw');

tentamen.done();
